//+--------------------MiniTD by Vadim647-----------------------------+
//| My small try to make a TD (TowerDefense) game that fits 100 lines |
//|   Sorry for poor features, but it's the only what fits the limit  |
//+------------------------Information--------------------------------+
//| If you ever played Warcraft 3, you know, what it is :)            |
//| If not, then:                                                     |
//| You need to kill creeps (green) that are trying to pass your      |
//| territory. they follow the predefined path                        |
//| To kill them, you need to build towers (red). There is one already|
//| To build towers, move your cursor over terrain, where's no road,  |
//| And press [1] to build.                                           |
//| To upgrade tower, move cursor over it, check if you have enough   |
//| gold, and press [9].                                              |
//| When upgrading tower, its damage increases. higher upgrades cost  |
//| more gold then first.                                             |
//| To earn gold, you need to kill creeps.                            |
//+--------------------------Misc-------------------------------------+
//| Because it's a LiteC project, it don't use levels.                |
//| So I made small system for calculating path using bones           |
//| I'm not pro in fast making of content, but anyway its a demo game.|
//+-------------------------------------------------------------------+
#include <acknex.h>
#include <default.c>
#define uvec1 skill22
#define uvec1y skill23
#define uvec1z skill24
#define uvec2 skill25
#define uvec2y skill26
#define uvec3 skill28
#define uspeed skill11
#define uspeeda skill12
#define uflags skill21
#define f_creep 1
#define f_tower 2
//^ some defines to make script editing easier.
BMAP* curmap = "cursor.tga";//Cursor bitmap source
var tdd_h[14] = {1,50,100,200,350,550,800,1100,1450,1850,2300,2800,3350,4000};
//^ Creep health database
VECTOR creepv;//Merged variables:CreepCount,CreepLevel,CreepMaxLevels
ENTITY* s_e;//Currently selected tower
ENTITY* level;//Level entity (for calculating path)
VECTOR t_v;	//two 'temp' vectors
VECTOR t_v2;//^
var t_i;//temp_integer
var resource = 20;//resource,gold,money... - for building,
ENTITY* t_e;//temp_entity
STRING* t_s="#100";//temp_string
PANEL* mainpan = //Upper left panel,shows that I made it, and some other info
{
	digits(4,4,"MiniTD by Vadim647
	Creep wave: %.0f","Arial#16bi",1,creepv.y);
	digits(4,36,"Resource: %.0f
	[1] - Build tower (when cursor is on green area) [10 gold]
	[9] - Upgrade current selected tower","Arial#16bi",1,resource);
	flags = VISIBLE;
}
//
function ent_rotate(rotate_angle,rotate_speed)	//function for smooth rotating.
{
	if (my.pan == rotate_angle) { return; }
	t_i = ang(rotate_angle - my.pan);
	if (t_i > 0) {c_rotate(my,vector( rotate_speed * time_step,0,0), IGNORE_PASSABLE);}
	if (t_i < 0) {c_rotate(my,vector(-rotate_speed * time_step,0,0), IGNORE_PASSABLE);}
	if ((ang(rotate_angle - my.pan) < 0 && t_i > 0)||
	(ang(rotate_angle - my.pan) > 0 && t_i < 0)){
		vec_set(my.pan,vector(rotate_angle,my.tilt,my.roll));}

}
//
function creep()	//The stupid creature, that hopes that it will pass path succesefully
{
	set(my,SHADOW|PASSABLE);
	my.uflags = f_creep;//Mark it, so towers will see it
	my.skill13 = 1;		//Path position
	my.skill1 = tdd_h[creepv.y];//Get health data from database
	while (my.skill1 > 0)
	{
		str_cpy(t_s,"way");														//Read next path point
		str_cat_num(t_s,"%.0f",my.skill13);										//from level entity
		vec_for_bone(my.uvec1,level,t_s);										//^
		vec_set(my.uvec2,vector(my.uvec1-my.x,my.uvec1y-my.y,my.uvec1z-my.z));	//and move to it
		vec_normalize(my.uvec2,5*time_step);									//^
		vec_to_angle(my.uvec3,my.uvec2);										//^
		ent_rotate(my.uvec3,25*time_step);			//rotate it.
		vec_add(my.x,vector(my.uvec2,my.uvec2y,0));	//move actualy
		if (vec_dist(my.x,my.uvec1)<4) my.skill13++;//if reached path point, move to next
		wait(1);
	}
	creepv.x--;//Reduce creep number
	resource += (creepv.y / 2 + 1) * (0.75 + random(0.5));//add reward for kill.
	ent_remove(me);
}
function tower()//Tower action, sample
{
	vec_set(my.skill1,vector(15,10,4));	//One of ways to cut semicolon count
	vec_set(my.skill4,vector(128,10,0));//
	my.uflags = f_tower;				//Mark it as tower, to upgrades avaible
	set(my,SHADOW);
	you = NULL;							//you -> target entity
	while(1)
	{
		my.skill16 = maxv(my.skill16-time_step,0);//<next scan at> var, to keep high fps
		if (you==NULL&&my.skill16<=0)	//If no target and its time to scan
		{
			my.skill16 = 1;//next scan later
			t_e = ent_next(NULL);//find first entity
			while (t_e != NULL)
			{
				if (vec_dist(t_e.x,my.x)<my.skill4&&t_e.uflags&f_creep)//if its a creep, and in range:
				{//If it's closer then last found, it made potential target
					if (you!=NULL)
					{
						if (vec_dist(t_e.x,my.x)<vec_dist(you.x,my.x)) you = t_e;
					}
					else
					{
						you = t_e;
					}
				}
				t_e = ent_next(t_e);
			}
		}
		my.skill11 = maxv(my.skill11-time_step,0);//weapon cooldown
		if (you!=NULL)
		{						//If there's a target and we can shoot:
			if (my.skill11 <= 0)//
			{
				draw_line3d(vector(my.x,my.y,my.z+my.max_z*0.7),NULL,100);				//Poor variant of
				draw_line3d(vector(my.x,my.y,my.z+my.max_z*0.7),vector(0,0,255),100);	//bullet animation
				draw_line3d(you.x,vector(0,0,255),100);									//at last, it's short
				my.skill11 = my.skill3;							//reset cooldown var
				you.skill1 -= my.skill1 + random(my.skill2);	//sub. targets health
				if (you.skill1 <= 0) you = NULL;				//if it gotta die, we don't have target anymore.
			}
			else {if (vec_dist(you.x,my.x)>my.skill4) you = NULL;}//if it's too far, it's not a target
		}
		wait(1);
	}
}

function spawn()	//function to spawn waves of creeps. nothing special
{
	vec_set(creepv,vector(0,0,3));
	while (creepv.y < 13)
	{
		vec_set(creepv,vector(0,creepv.y+1,0));
		while (creepv.z < 16) {creepv.z += 1;ent_create("td_creep.mdl",vector(-192,192,16),creep);wait(-1);}
		creepv.x += creepv.z;
		while (creepv.x > 0) wait(1);
		beep();
	}
}
function key1() //build a tower at mouse position.
{
	if (target.z == 0 && resource >= 10) {ent_create("td_tower.mdl",target.x,tower);resource -= 10;}
}
function key2() //upgrade selected tower
{
	if (s_e!=NULL && resource >= s_e.skill5) {resource-=s_e.skill5;s_e.skill1 *= 2;s_e.skill2 *= 2;s_e.skill5 += 10;}
}
function main()
{
	video_switch(8,0,1);fps_max = 60;//Set 1024x768 fullscreen and 60 fps maximum.
	shadow_stencil = 2;				//use stencil shadows, because we don't have level ents here
	level_load(NULL);				//load empty level
	mouse_map = curmap;				//set mouse map and mode
	mouse_mode = 4;					// -2 semicolons
	wait(3);						//7.05 engine needs to wait before level loads, even when it's no level at all
	level = ent_create("td_level.mdl",nullvector,NULL);//create a level entity
	spawn();						//activate spawning algoritm
	s_e = ent_create("td_tower.mdl",vector(32,32,0),tower);//create sample tower and select it
	set(level,SHADOW|FLAG2);				//set shadow cast
	vec_set(camera.x,vector(146,-320,455));	//set camera position and angle
	vec_set(camera.pan,vector(117,-58,0));	//^
	on_1 = key1;	//set keys
	on_9 = key2;	//^
	draw_textmode("Arial",3,16,100);
	while(1)
	{
		vec_set(t_v,vector(mouse_cursor.x,mouse_cursor.y,10));
		vec_set(t_v2,vector(t_v.x,t_v.y,5000));
		vec_for_screen(t_v,camera);
		vec_for_screen(t_v2,camera);
		c_trace(t_v,t_v2,IGNORE_PASSABLE|USE_POLYGON);//trace cursor position for ents
		if (you!=NULL) 
		{
		if (you.uflags&f_tower)//if its a tower, select it
		{
			s_e = you;
		}
		}
		str_cpy(t_s,"");//draw some info about selected object
		str_cat_num(t_s,"Current wave health: %.0f\n",tdd_h[creepv.y]);
		str_cat_num(t_s,"-Current selected tower-\nBase damage: %.0f",s_e.skill1);
		str_cat_num(t_s,"\nAdd damage: %.0f",s_e.skill2);
		str_cat_num(t_s,"\nRange: %.0f",s_e.skill4);
		str_cat_num(t_s,"\nUpgrade cost: %.0f",s_e.skill5);
		draw_text(t_s,4,640,vector(255,255,255));
		wait(1);
	}
}